## prog.utili
Class Occorrenza<E>

    java.lang.Object
      prog.utili.Occorrenza<E>

Direct Known Subclasses:
  OccorrenzaOrdinata

    public class Occorrenza<E>

extends java.lang.Object

Un'istanza della classe fornisce un contatore per le occorrenze di un oggetto di tipo `E`

Version:
  2.0
Author:
  Mauro Ferrari, Giovanni Pighizzini

Constructor Summary
`Occorrenza(E o)` Crea un nuovo contatore per l'oggetto specificato come argomento, il valore iniziale del contatore è 1.
`Occorrenza(E o, int contatore)` Crea un nuovo contatore per l'oggetto specificato come primo argomento, il valore iniziale del contatore è quello specificato come secondo argomento.

Method Summary
`boolean` `equals(java.lang.Object altro)` Restituisce `true` se l'oggetto che esegue il metodo è un'istanza di `Occorrenza` e l'occorrenza che esegue il metodo si riferisce a un oggetto uguale a quello a cui fa riferimento l'occorrenza fornita come argomento, restituisce `false` in caso contrario.
`boolean` `equals(Occorrenza<E> altra)` Restituisce `true` se l'occorrenza che esegue il metodo si riferisce a un oggetto uguale a quello a cui fa riferimento l'occorrenza fornita come argomento, restituisce `false` in caso contrario.
`E` `get()` Restituisce l'oggetto di cui l'istanza che esegue il metodo conta le occorrenze.
`int` `getValoreContatore()` Restituisce il valore del contatore delle occorrenze dell'istanza che esegue il metodo.
`void` `incrementa()` Incrementa il contatore delle occorrenze dell'istanza che esegue il metodo.
`java.lang.String` `toString()` Restituisce una stringa che descrive l'occorrenza che esegue il metodo.

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Occorrenza

    public Occorrenza(E o)

  Crea un nuovo contatore per l'oggetto specificato come argomento, il valore iniziale del contatore è 1.

  Parameters:
    `o` - l'oggetto a cui si riferisce l'occorrenza.

### Occorrenza

    public Occorrenza(E o,
                      int contatore)

  Crea un nuovo contatore per l'oggetto specificato come primo argomento, il valore iniziale del contatore è quello specificato come secondo argomento.

  Parameters:
    `o` - l'oggetto a cui si riferisce l'occorrenza.
    `contatore` - il valore iniziale del contatore.

Method Detail

### get

    public E get()

  Restituisce l'oggetto di cui l'istanza che esegue il metodo conta le occorrenze.

  Returns:
    l'oggetto di cui l'istanza che esegue il metodo conta le occorrenze.

### toString

    public java.lang.String toString()

  Restituisce una stringa che descrive l'occorrenza che esegue il metodo.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    la stringa che descrive l'occorrenza.

### equals

    public boolean equals(java.lang.Object altro)

  Restituisce `true` se l'oggetto che esegue il metodo è un'istanza di `Occorrenza` e l'occorrenza che esegue il metodo si riferisce a un oggetto uguale a quello a cui fa riferimento l'occorrenza fornita come argomento, restituisce `false` in caso contrario. Il criterio di uguaglianza è quello definito dal metodo `equals` di `E`.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `altro` - l'oggetto da confronatare con l'occorrenza che esegue il metodo.
  Returns:
    true se e solo se l'oggetto fornito come argomento è un'occorrenza uguale a quella che esegue il metodo.

### equals

    public boolean equals(Occorrenza<E> altra)

  Restituisce `true` se l'occorrenza che esegue il metodo si riferisce a un oggetto uguale a quello a cui fa riferimento l'occorrenza fornita come argomento, restituisce `false` in caso contrario. Il criterio di uguaglianza è quello definito dal metodo `equals` di `E`. Si osservi che due occorrenze di due oggetti uguali sono considerate uguali, anche se i contatori sono differenti.

  Parameters:
    `altra` - l'occorrenza da confrontare con quella che esegue il metodo.
  Returns:
    true se e solo se l'occorrenza che esgue il metodo è uguale a quella fornita come argomento.

### incrementa

    public void incrementa()

  Incrementa il contatore delle occorrenze dell'istanza che esegue il metodo.

### getValoreContatore

    public int getValoreContatore()

  Restituisce il valore del contatore delle occorrenze dell'istanza che esegue il metodo.